unit Main;

{
Sample for TAPI 1.0 Component for Delphi 2.0 32 bit!
Copyright by Robin Heilos (c)1997, all rights reserved.
TAPI v1.0 is Shareware ! Please read the 'Licens.Txt'
-------------------------------------------------------


This is a very easy sample for using the TAPI-component. But please look to the
procedure "OnDisConnected_Busy" ! Note : "OnBusy" and "OnDisConnected_Busy" are two
different events !

Some events are working with two parameters, e.c :

DisConnected  (1. Event)  => Now i know, that the componet is disconnected,
   |
   |_   DisConnected_Busy         (2. Event) => because the line was busy
   |
   or
   |_   DisConnected_NoDialTone   (2. Event) => because no dialtone was found
   |
   or
   |_   DisConnected_Normal       (2. Event) => because the "user" have end the connection normaly.



I have insert all events, that you can see how this componet is working. Normaly you
can handle some events with one and global event-procedure.


Robin Heilos
Unter dem Heiligenwald 7
35096 Wolfshausen
(Germany)

Phone    : +49-6421-77350
Internet : Robin.Heilos@mni.fh-giessen.de
Fido     : 2:2461/134
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ApiComp32,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ComboBox: TComboBox;
    API: TAPI;
    Label1: TLabel;
    StatusList: TListBox;
    EPhoneNumber: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure APINoDialtone(Sender: TObject);
    procedure APIDialing(Sender: TObject);
    procedure APIDisConnected(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure EPhoneNumberChange(Sender: TObject);
    procedure APIConnected(Sender: TObject);
    procedure APIErrorNoDevices(Sender: TObject);
    procedure APIErrorTAPIVersion(Sender: TObject);
    procedure APIProceeding(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure APIError_Unknown(Sender: TObject; ErrorMsg, ErrorParam1,
      ErrorParam2, ErrorParam3: Longint);
    procedure APIAccepted(Sender: TObject);
    procedure APIBusy(Sender: TObject);
    procedure APIBusy_Station(Sender: TObject);
    procedure APIBusy_Trunk(Sender: TObject);
    procedure APIBusy_Unavail(Sender: TObject);
    procedure APIBusy_Unknown(Sender: TObject);
    procedure APIDeallocated(Sender: TObject);
    procedure APIDialtone(Sender: TObject);
    procedure APIDialTone_External(Sender: TObject);
    procedure APIDialTone_Internal(Sender: TObject);
    procedure APIDialTone_Normal(Sender: TObject);
    procedure APIDialTone_Special(Sender: TObject);
    procedure APIDialTone_Unavail(Sender: TObject);
    procedure APIDialTone_Unknown(Sender: TObject);
    procedure APIDisConnected_Busy(Sender: TObject);
    procedure APIDisConnected_NoDialTone(Sender: TObject);
    procedure APIDisConnected_Normal(Sender: TObject);
    procedure APIError_Initialize(Sender: TObject);
    procedure APIError_NoDevices(Sender: TObject);
    procedure APIError_Reply(Sender: TObject);
    procedure APIError_TAPIVersion(Sender: TObject);
    procedure APIReplyOk(Sender: TObject);
    procedure APIRingback(Sender: TObject);
    procedure APISpecialInfo(Sender: TObject);
    procedure APISpecialInfo_Custirreg(Sender: TObject);
    procedure APISpecialInfo_NoCircuit(Sender: TObject);
    procedure APISpecialInfo_Reorder(Sender: TObject);
    procedure APISpecialInfo_Unavail(Sender: TObject);
    procedure APISpecialInfo_Unknown(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Procedure TForm1.FormCreate(Sender: TObject);
Begin
 ComboBox.Items := API.DeviceModemList;
 If ComboBox.Items.Count > 0 then begin;
  ComboBox.ItemIndex := 0;
 End;
 EPhoneNumber.Text := API.Phonenumber;
End;

Procedure TForm1.ComboBoxChange(Sender: TObject);
Begin
 If ComboBox.Items.Count > 0 then begin;
  API.Device := ComboBox.ItemIndex;
 End;
End;


procedure TForm1.APINoDialtone(Sender: TObject);
begin
 StatusList.Items.Add('No dialtone !');
end;

procedure TForm1.APIDialing(Sender: TObject);
begin
 StatusList.Items.Add('Dialing...');
end;

procedure TForm1.APIDisConnected(Sender: TObject);
begin
 StatusList.Items.Add('Disconnected !');
end;

Procedure TForm1.EPhoneNumberChange(Sender: TObject);
Begin
 API.Phonenumber := EPhonenumber.Text;
End;

procedure TForm1.APIConnected(Sender: TObject);
begin
 StatusList.Items.Add('Connected !');
end;

procedure TForm1.APIErrorNoDevices(Sender: TObject);
begin
 StatusList.Items.Add('No devices found !');
end;

procedure TForm1.APIErrorTAPIVersion(Sender: TObject);
begin
 StatusList.Items.Add('Can''t make a call with this TAPI.DLL - Version !');
end;

procedure TForm1.APIProceeding(Sender: TObject);
begin
 StatusList.Items.Add('Proceeding...');
end;


Procedure TForm1.APIError_Unknown(Sender: TObject; ErrorMsg, ErrorParam1,
  ErrorParam2, ErrorParam3: Longint);
Begin
  StatusList.Items.Add('Unknown error : '+IntToStr(ErrorMsg)+','
                                        +IntToStr(ErrorParam1)+','
                                        +IntToStr(ErrorParam2)+','
                                        +IntToStr(ErrorParam3));
End;

procedure TForm1.APIAccepted(Sender: TObject);
begin
 StatusList.Items.Add('Accepted !');
end;

procedure TForm1.APIBusy(Sender: TObject);
begin
  StatusList.Items.Add('Busy :');
end;


procedure TForm1.APIBusy_Station(Sender: TObject);
begin
 StatusList.Items.Add(' - Station');
end;

procedure TForm1.APIBusy_Trunk(Sender: TObject);
begin
 StatusList.Items.Add(' - Trunk');
end;

procedure TForm1.APIBusy_Unavail(Sender: TObject);
begin
 StatusList.Items.Add(' - Unavail');
end;

procedure TForm1.APIBusy_Unknown(Sender: TObject);
begin
 StatusList.Items.Add(' - Unknown');
end;

procedure TForm1.APIDeallocated(Sender: TObject);
begin
 StatusList.Items.Add('Deallocated');
end;

procedure TForm1.APIDialtone(Sender: TObject);
begin
 StatusList.Items.Add('Dialtone :');
end;

procedure TForm1.APIDialTone_External(Sender: TObject);
begin
 StatusList.Items.Add(' - External');
end;

procedure TForm1.APIDialTone_Internal(Sender: TObject);
begin
  StatusList.Items.Add(' - Internal');
end;


procedure TForm1.APIDialTone_Normal(Sender: TObject);
begin
 StatusList.Items.Add(' - Normal');
end;

procedure TForm1.APIDialTone_Special(Sender: TObject);
begin
  StatusList.Items.Add(' - Special');
end;

procedure TForm1.APIDialTone_Unavail(Sender: TObject);
begin
  StatusList.Items.Add(' - Unavail');
end;

procedure TForm1.APIDialTone_Unknown(Sender: TObject);
begin
  StatusList.Items.Add(' - Unknown');
end;

procedure TForm1.APIDisConnected_Busy(Sender: TObject);
begin
  StatusList.Items.Add(' - Busy');
end;

procedure TForm1.APIDisConnected_NoDialTone(Sender: TObject);
begin
  StatusList.Items.Add(' - No dial tone');
end;

procedure TForm1.APIDisConnected_Normal(Sender: TObject);
begin
  StatusList.Items.Add(' - normal');
end;

procedure TForm1.APIError_Initialize(Sender: TObject);
begin
  StatusList.Items.Add(' Error : Line initialize');
end;

procedure TForm1.APIError_NoDevices(Sender: TObject);
begin
 StatusList.Items.Add('Error : No devices found');
end;

procedure TForm1.APIError_Reply(Sender: TObject);
begin
 StatusList.Items.Add('Error : No line reply');
end;

procedure TForm1.APIError_TAPIVersion(Sender: TObject);
begin
 StatusList.Items.Add('Error : No compatible TAPI version');
end;

procedure TForm1.APIReplyOk(Sender: TObject);
begin
 StatusList.Items.Add('Reply : OK !');
end;

procedure TForm1.APIRingback(Sender: TObject);
begin
 StatusList.Items.Add('Ringback...');
end;

procedure TForm1.APISpecialInfo(Sender: TObject);
begin
 StatusList.Items.Add('Special info : ');
end;

procedure TForm1.APISpecialInfo_Custirreg(Sender: TObject);
begin
  StatusList.Items.Add(' - Custirreg');
end;



procedure TForm1.APISpecialInfo_NoCircuit(Sender: TObject);
begin
 StatusList.Items.Add(' - No circuit');
end;

procedure TForm1.APISpecialInfo_Reorder(Sender: TObject);
begin
 StatusList.Items.Add(' - Reorder');
end;

procedure TForm1.APISpecialInfo_Unavail(Sender: TObject);
begin
 StatusList.Items.Add(' - Unavail');
end;

procedure TForm1.APISpecialInfo_Unknown(Sender: TObject);
begin
 StatusList.Items.Add(' - Unknown');
end;

Procedure TForm1.SpeedButton1Click(Sender: TObject);
Begin
 StatusList.Clear;
 API.Connect;
End;

Procedure TForm1.SpeedButton2Click(Sender: TObject);
Begin
 API.Disconnect;
End;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 API.MediaMode := mmModem;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 API.MediaMode := mmVoice;
end;

end.
